<script>
import { mapState } from 'vuex';
import _ from 'lodash';

import * as animRigApiRoutes from '~/helpers/api-routes/anim-rig.js';
import * as usersApiRoutes from '~/helpers/api-routes/users.js';

import AdminProjectsDashboard from '~/components/admin/projects-dashboard.vue';
import AdminWebsocketsDashboard from '~/components/admin/websockets-dashboard.vue';
import AdminUsersDashboard from '~/components/admin/users-dashboard.vue';

export default {
  name: `page-admin`,
  components: {
    AdminProjectsDashboard,
    AdminWebsocketsDashboard,
    AdminUsersDashboard,
  },
  data() {
    return {
      libraries: [],
      users: [],
    }
  },
  async asyncData (nuxtContext) {
    const { $axios, app, error } = nuxtContext;
    const isAdmin = app.store.state.users.currentUser.roles.includes(`admin`);
    let libraries = [];
    let users = [];
    if (isAdmin) {
      const params = { showInactive: true, getPoses: false };
      try {
        libraries = await $axios.$get(animRigApiRoutes.listAllLibraries(), { params });
        users = await $axios.$get(usersApiRoutes.list());
      } catch (err) {
        error(err);
      }
    }
    return { libraries, users };
  },
  computed: {
    ...mapState({
      isAdmin: (state) => state.users.currentUser.roles.includes(`admin`),
    }),
  },
  watch: {
    [`$store.state.projects.projects`](newProjects) {
      const libs = _.cloneDeep(this.libraries);
      const remainingIds = libs.map(l => l.id);
      for (const p of newProjects) {
        for (const l of p.animRigLibraries) {
          _.find(libs, [`id`, l.id]).parent_project = p.id;
          _.remove(remainingIds, (n) => n === l.id);
        }
      }
      for (const id of remainingIds) {
        _.find(libs, [`id`, id]).parent_project = null;
      }
      this.libraries = libs;
    },
  },
}
</script>

<template>
  <div>
    <div class="text-h5">{{ $t(`admin.title`) }}</div>
    <v-divider class="my-4" />
    <admin-projects-dashboard :libraries="libraries" :users="users" />
    <admin-websockets-dashboard class="mt-1" />
    <admin-users-dashboard v-if="isAdmin" :users="users" class="mt-1" />
  </div>
</template>
